import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "SaelythPlugins.PersonalStrats"

Turbine.Shell.WriteLine(".\n<rgb=#ff0000>- Saelyth's PersonalStrats plugin Version 1.7 Loaded -</rgb>\n<rgb=#17F200> Double-Click on the PS icon to open it.\n (Also works if you type '/PS show' in the chat window).\n\n Hold down the Ctrl key to drag the icon.</rgb>\nAnd remember to check for updates weekly!\n.");

windowSettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "PersonalStratsSettings" );
NotaCargadaVariable = Turbine.PluginData.Load( Turbine.DataScope.Character, "PersonalStratsNotes" );

Hellish = HellishWindow();
Hellish:SetVisible( false );
ItemsID = ItemsIDWindow();
ItemsID:SetVisible( false );
Rename = RenameitemsWindow();
Rename:SetVisible( false );
Timercillo = TimerWindow();
Timercillo:SetVisible( false );


minimizado = Turbine.UI.Window();
	if type( windowSettings ) ~= "table" then
		windowSettings = { minisizewidth = 61, minisizeheight = 50 };
	else
		if windowSettings.minisizewidth == nil then
			windowSettings.minisizewidth = 61;
		end
		if windowSettings.minisizeheight == nil then
			windowSettings.minisizeheight = 50;
		end
	end
minimizado:SetSize( windowSettings.minisizewidth, windowSettings.minisizeheight );
minimizado:SetBackground("SaelythPlugins/PersonalStrats/Resources/minimizado.jpg");
minimizado:SetPosition( windowSettings.positionminiX, windowSettings.positionminiY );
minimizado:SetVisible(true);

minimizado.MouseDoubleClick = function (sender, args)
	if Hellish:IsVisible() == false and (displayWindow==nil or not displayWindow:IsVisible()) then
		Hellish:SetVisible(true)
	end;
end

minimizadoDragging = false;
minimizado.MouseDown = function (sender, args)
	if minimizado:IsControlKeyDown() then
		minimizadoDragging = true;
	end
end

minimizado.MouseUp = function (sender, args)
	minimizadoDragging = false;
end

minimizado.MouseMove = function (sender, args)
	if minimizadoDragging == true then
		local curX = Turbine.UI.Display.GetMouseX();
		local curY = Turbine.UI.Display.GetMouseY();
		local scWidth = Turbine.UI.Display.GetWidth();
		local scHeight = Turbine.UI.Display.GetHeight();
		local curLeft = curX - 30;
		local curTop = curY -25;
		if (curX-30) < 0 then curLeft = 0 end;
		if (curX+30) > scWidth then curLeft = scWidth-61 end;
		if (curY-25) < 0 then curTop = 0 end;
		if (curY+25) > scHeight then curTop = scHeight-50 end;
		minimizado:SetLeft(curLeft);
		minimizado:SetTop(curTop);
		local farRight = minimizado:GetLeft() + minimizado:GetWidth();
		if farRight > Turbine.UI.Display.GetWidth() then
			minimizado:SetLeft(minimizado:GetLeft());
		else
			minimizado:SetLeft(minimizado:GetLeft());
		end
	end
end

-- Hide UI when F12 is pressed (copy/pasted from LotroPad)
Settings = {  ToggleVisible = "yes" };
local hideUI = false;
wasVisible=true;
hellishVisible=false; 
displayVisible=false; 

minimizado:SetWantsKeyEvents(true);
minimizado.KeyDown = function(sender, args)
	if (args.Action == 268435635) then
		if not hideUI then
			hideUI = true;
			if minimizado:IsVisible() then
				wasVisible = true;
				minimizado:SetVisible(false);
				if minimizado.imgWindow then
					minimizado.imgWindow:SetVisible(false);
				end
			else
				wasVisible = false;
			end
			if Hellish:IsVisible() then
				hellishVisible=true;
				Hellish:SetVisible(false);
			else
				hellishVisible=false;
			end
			if displayWindow~=nil and displayWindow:IsVisible() then
				displayVisible=true;
				displayWindow:SetVisible(false);
			else
				displayVisible=false;
			end
		else
			hideUI = false;
			if wasVisible then
				minimizado:SetVisible(true);			
			end
			if hellishVisible then
				Hellish:SetVisible(true);
			end
			if displayVisible and displayWindow~=nil then
				displayWindow:SetVisible(true);
			end
			if (Settings.ToggleVisible == "yes") then
			end
		end
	elseif (args.Action==Turbine.UI.Lotro.Action.Escape) then
		Hellish:SetVisible(false);
		if displayWindow~=nil then
			displayWindow:SetVisible(false);
		end
	end
end


HellishShellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand("PS",HellishShellCmd);

HellishShellCmd.Execute = function(sender, cmd, args)
	if (string.lower(args)=="show") then
		if displayWindow==nil or not displayWindow:IsVisible() then
			Hellish:SetVisible(true);
		end
	elseif (string.lower(args)=="hide") then
		if displayWindow~=nil then
			displayWindow:SetVisible(false);
		end
		Hellish:SetVisible(false);
	elseif (string.lower(args)=="toggle") then
		if displayWindow==nil then
			Hellish:SetVisible(not Hellish:IsVisible())
		else
			if displayWindow:IsVisible() then
				displayWindow:SetVisible(false);
			else
				Hellish:SetVisible(not Hellish:IsVisible())
			end
		end
	else
		Turbine.Shell.WriteLine("usage:");
		Turbine.Shell.WriteLine("  /PS show");
		Turbine.Shell.WriteLine("       Displays the Personal Strategies main window.");
		Turbine.Shell.WriteLine("  /PS hide");
		Turbine.Shell.WriteLine("       Hides the Personal Strategies main window.");
		Turbine.Shell.WriteLine("  /PS toggle");
		Turbine.Shell.WriteLine("       Toggles the Personal Strategies main window (shows it if it was hidden, hides it if it was showing).");
	end
end
HellishShellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /PS show\n       Displays the Personal Strategies main window.\n  /PS hide\n       Hides the Personal Strategies main window.\n  /PS toggle\n       Toggles the Personal Strategies main window (shows it if it was hidden, hides it if it was showing).");
end
HellishShellCmd.GetShortHelp = function(sender, cmd)
	return("PS - usage: /PS show | hide | toggle");
end

plugin.Unload=function()
	-- this function gets called when the plugin unloads and will execute saves instantly (no callback)

	windowSettings.positionminiX, windowSettings.positionminiY=minimizado:GetPosition();
	windowSettings.positionX, windowSettings.positionY=Hellish:GetPosition();
	windowSettings.positionXtimer, windowSettings.positionYtimer=Timercillo:GetPosition();
	windowSettings.positionXrenamer, windowSettings.positionYrenamer=Rename:GetPosition();
	windowSettings.positionXitemsid, windowSettings.positionYitemsid=ItemsID:GetPosition();
	Turbine.PluginData.Save( Turbine.DataScope.Character, "PersonalStratsSettings", windowSettings );

	-- added shell command functionality 9/17 Garan
	-- remove the shell commands
	Turbine.Shell.RemoveCommand(HellishShellCmd)
end