StratDisplayWindow=class(Turbine.UI.Lotro.Window);
function StratDisplayWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

	self:LoadSettings();
		
	-- Window settings
	self:SetSize(365, 140);
	self:SetOpacity(1);
	self:SetPosition( windowSettings.positionXstratdisplay, windowSettings.positionYstratdisplay );

	-- control added to allow background images on the button display
	self.Background=Turbine.UI.Control();
	self.Background:SetParent(self);
	self.Background:SetSize(self:GetWidth()-10,self:GetHeight()-80);
	self.Background:SetPosition(5,45);

               -- Back button
	self.volverButton = Turbine.UI.Lotro.Button();
	self.volverButton:SetParent( self );
	self.volverButton:SetPosition(420, 20);
	self.volverButton:SetWidth( 50 );
	self.volverButton:SetText("Back");
	self.volverButton:SetVisible( false );
	self.volverButton.Click = function()
	        self:SetSize(365, 140);
		for k,v in pairs(self.customButtons) do
			v:SetVisible(true);
		end
		self.volverButton:SetVisible( false );
		self.DisplayFrame:ClearItems();
		self.DisplayFrame:SetVisible(false);
		-- this block will resize the window to it's default or to the size of the background image if one is present
				if stratName==nil or StratData[stratName]==nil or StratData[stratName].imagePath==nil then
			self.CurrentWidth=365;
			self:SetSize(365, 140);
		else
			self.Background:SetVisible(true);
			self.CurrentWidth=StratData[stratName].imageWidth+10;
			self:SetSize(StratData[stratName].imageWidth+10,StratData[stratName].imageHeight+80);
		end
		self.ChannelCaption:SetVisible(false);
		self.ChannelText:SetVisible(false);

	end
	self.DisplayFrame = Turbine.UI.ListBox();
	self.DisplayFrame:SetParent(self);
	self.DisplayFrame:SetVisible(false);
	self.DisplayFrame:SetSize(20,20); -- just so we can set the scrollbar
	self.DisplayScroll=Turbine.UI.Lotro.ScrollBar();
	self.DisplayScroll:SetParent(self);
	self.DisplayScroll:SetSize(10,20);
	self.DisplayScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.DisplayFrame:SetVerticalScrollBar(self.DisplayScroll);

	self.ChannelCaption=Turbine.UI.Label();
	self.ChannelCaption:SetParent(self);
	self.ChannelCaption:SetSize(280,20);
	self.ChannelCaption:SetPosition(40,self:GetHeight()-30);
	self.ChannelCaption:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ChannelCaption:SetText("Type the channel you want to use here:");
	self.ChannelText=Turbine.UI.Lotro.TextBox();
	self.ChannelText:SetParent(self);
	self.ChannelText:SetSize(100,20);
	self.ChannelText:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ChannelText:SetPosition(self.ChannelCaption:GetLeft()+self.ChannelCaption:GetWidth(),self.ChannelCaption:GetTop());
	self.ChannelText:SetText("/say");
	self.ChannelText.FocusGained=function()
		self.ChannelText:SetWantsUpdates(true);
	end
	self.ChannelText.FocusLost=function()
		self.ChannelText:SetWantsUpdates(false);
		self.ChannelText:Update();
	end
	self.ChannelText.Update=function()
		local tmpText=self.ChannelText:GetText();
		for tmpIndex=1,self.DisplayFrame:GetItemCount() do
			tmpControl=self.DisplayFrame:GetItem(tmpIndex)
			if tmpControl.Child~=nil then
				for tmpIndex=1,#tmpControl.Child do
					if tmpControl.Child[tmpIndex].QS~=nil then
						local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
						sc:SetData(tmpText.." "..tmpControl.Child[tmpIndex].QS.data.."<rgb=#6F6F6F> - [From PersonalStrats Plugin]</rgb>");
						tmpControl.Child[tmpIndex].QS:SetShortcut(sc);
					end
				end
			end
		end
	end

	self.ChannelCaption:SetVisible(false);
	self.ChannelText:SetVisible(false);

	-- custom button array
	self.customButtons={}
	self.ClearDisplay=function()
		for k,v in pairs(self.customButtons) do
			v:SetVisible(false);
			v.Click=nil;
			v=nil;
			self.customButtons[k]=nil;
		end
		self.ChannelCaption:SetVisible(false);
		self.ChannelText:SetVisible(false);
		self.DisplayFrame:ClearItems();
		self.displayTop=35;
		self.DisplayScroll:SetVisible(false);
	end
	self.AddCustomButton=function(title,x,y,width,displayElements)
		local tmpButton=Turbine.UI.Lotro.Button();
		tmpButton:SetParent(self);
		tmpButton:SetWidth(width);
		tmpButton:SetPosition(x,y);
		tmpButton.displayElements=displayElements;
		tmpButton.Click=function(sender,args)
			for k,v in ipairs(sender.displayElements) do
				self.AddDisplayControl(v[1],v[2],v[3],v[4],v[5],v[6],v[7],v[8],v[9],v[10],v[11]);
			end
			self:ShowDisplayFrame();
		end
		tmpButton:SetText(title);
		table.insert(self.customButtons,tmpButton);
		if y+tmpButton:GetHeight()>self.displayTop then
			self.displayTop=y+tmpButton:GetHeight();
		end
	end

-- added the initEvent, listIndex, left and top parameters 9/17 Garan -- note, there are many changes to AddDisplayControl so the entire method should be considered as modified
	self.AddDisplayControl=function(type,width,height,data,color,font,clickEvent,initEvent,listIndex,left,top)
		local tmpControl;
		-- added to allow multiple elements in a row 9/17 Garan
		if listIndex==nil then
			tmpControl=Turbine.UI.Control();
			tmpControl:SetSize(self.DisplayFrame:GetWidth(),height)
			tmpControl:SetMouseVisible(false);
		else
			if listIndex<=self.DisplayFrame:GetItemCount() then
				tmpControl=self.DisplayFrame:GetItem(listIndex);
			else
				-- the display element specified an invalid index, just create a new row until we can figure out a better solution
				tmpControl=Turbine.UI.Control();
				tmpControl:SetSize(self.DisplayFrame:GetWidth(),height)
				tmpControl:SetMouseVisible(false);
			end
		end
-- added .Child table to tmpControl so that we can treat all new objects as child controls 9/17 Garan
		if tmpControl.Child==nil then tmpControl.Child={} end
		local newChildIndex=#tmpControl.Child+1

		if type=="image" then
			tmpControl.Child[newChildIndex]=Turbine.UI.Control();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetBackground(data);
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			if left==nil then
				tmpControl.Child[newChildIndex]:SetLeft((self.DisplayFrame:GetWidth()-width)/2); -- center the button
				tmpControl.Child[newChildIndex].Centered=true;
			else
				tmpControl.Child[newChildIndex]:SetLeft(left);
			end
			if clickEvent~=nil then
				tmpControl.Child[newChildIndex].MouseClick = clickEvent
			end

		elseif type=="text" then
			self.ChannelCaption:SetVisible(true);
			self.ChannelText:SetVisible(true);

-- removed 9/17 Garan -- row width is now controlled by tmpControl but each element has its own width within the row
--			width=self.DisplayFrame:GetWidth();
			if width==nil then width =self.DisplayFrame:GetWidth() end
			-- need a container around the actual label so we can add the quickslot and its label
			tmpControl.Child[newChildIndex]=Turbine.UI.Label();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetSelectable(true)
			if color~=nil then
				tmpControl.Child[newChildIndex]:SetForeColor(color);
			end
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			tmpControl.Child[newChildIndex]:SetText(data);
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			if newChildIndex==1 or (height+20>tmpControl:GetHeight()) then
				tmpControl:SetHeight(height+20);
			end

			tmpControl.Child[newChildIndex].QSBorder=Turbine.UI.Control();
			tmpControl.Child[newChildIndex].QSBorder:SetParent(tmpControl);
			tmpControl.Child[newChildIndex].QSBorder:SetSize(120,20);
			tmpControl.Child[newChildIndex].QSBorder:SetPosition((width-120)/2,height)
			tmpControl.Child[newChildIndex].QS=Turbine.UI.Lotro.Quickslot();
			tmpControl.Child[newChildIndex].QS:SetParent(tmpControl.Child[newChildIndex].QSBorder);
			tmpControl.Child[newChildIndex].QS:SetBackColor(Turbine.UI.Color(0,0,0));
			tmpControl.Child[newChildIndex].QS:SetSize(154,54);
			tmpControl.Child[newChildIndex].QS:SetPosition(-34,-34); -- position it at a negative location to suppress the "/A" icon
			local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
			sc:SetData(self.ChannelText:GetText().." "..data.."<rgb=#6F6F6F> - [From PersonalStrats Plugin]</rgb>");
			tmpControl.Child[newChildIndex].QS:SetShortcut(sc);
			tmpControl.Child[newChildIndex].QS.data=data;
			tmpControl.Child[newChildIndex].QS:SetAllowDrop(false);
			tmpControl.Child[newChildIndex].QS.DragDrop=function(sender)
				local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
				sc:SetData(self.ChannelText:GetText().." "..sender.data.."<rgb=#6F6F6F> - [From PersonalStrats Plugin]</rgb>");
				sender:SetShortcut(sc);	
			end

			tmpControl.Child[newChildIndex].QSLabel=Turbine.UI.Label();
			tmpControl.Child[newChildIndex].QSLabel:SetParent(tmpControl.Child[newChildIndex].QSBorder);
			tmpControl.Child[newChildIndex].QSLabel:SetSize(120,20);
			tmpControl.Child[newChildIndex].QSLabel:SetBackColor(Turbine.UI.Color(50,50,50))
			tmpControl.Child[newChildIndex].QSLabel:SetForeColor(Turbine.UI.Color(0,0,0))
			tmpControl.Child[newChildIndex].QSLabel:SetPosition(0,0);
			tmpControl.Child[newChildIndex].QSLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			tmpControl.Child[newChildIndex].QSLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			tmpControl.Child[newChildIndex].QSLabel:SetText("Send to Chat");
			tmpControl.Child[newChildIndex].QSLabel:SetMouseVisible(false);
-- added checkbox control 9/17 Garan
		elseif type=="checkbox" then
			tmpControl.Child[newChildIndex]=Turbine.UI.Lotro.CheckBox();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetVisible( true );
			tmpControl.Child[newChildIndex]:SetMouseVisible( true );
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			if left==nil then left=0 end
			if top==nil then top=0 end
			tmpControl.Child[newChildIndex]:SetPosition(left,top);
			tmpControl.Child[newChildIndex]:SetText(data);
			tmpControl.Child[newChildIndex]:IsMultiline( false )

		elseif type=="textbox" then
			tmpControl.Child[newChildIndex]=Turbine.UI.Lotro.TextBox();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetVisible( true );
			tmpControl.Child[newChildIndex]:SetMouseVisible( true );
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			if left==nil then left=0 end
			if top==nil then top=0 end
			tmpControl.Child[newChildIndex]:SetPosition(left,top);
			tmpControl.Child[newChildIndex]:SetText(data);
			tmpControl.Child[newChildIndex]:IsMultiline( false )
-- added a separate multi-line textbox control 9/17 Garan
		elseif type=="multilinetextbox" then
			tmpControl.Child[newChildIndex]=Turbine.UI.Lotro.TextBox();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetVisible( true );
			tmpControl.Child[newChildIndex]:SetMouseVisible( true );
			tmpControl.Child[newChildIndex]:SetSize(width,height);	
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			if left==nil then left=0 end
			if top==nil then top=0 end
			tmpControl.Child[newChildIndex]:SetPosition(left,top);
			tmpControl.Child[newChildIndex]:SetText(data);
			tmpControl.Child[newChildIndex]:IsMultiline( true )

		elseif type=="button" then
			if height==nil then height=20 end;
			if width==nil then width=self.DisplayFrame:GetWidth() end;
			tmpControl.Child[newChildIndex]=Turbine.UI.Lotro.Button();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			if left==nil then
				tmpControl.Child[newChildIndex]:SetLeft((self.DisplayFrame:GetWidth()-width)/2); -- center the button
				tmpControl.Child[newChildIndex].Centered=true;
			else
				tmpControl.Child[newChildIndex]:SetLeft(left);
			end
			tmpControl.Child[newChildIndex]:SetText(data);
			if clickEvent~=nil then
				tmpControl.Child[newChildIndex].Click = clickEvent
			end

		elseif type=="quickslot" then
			local QStype=Turbine.UI.Lotro.ShortcutType.Alias;
			local QSdata="";
			-- parse data for optional quickslot type (format "type:data") where type is a number
			local tmpVals=({string.match(data,"([0-9]+):(.*)")})
			if tmpVals~=nil and tonumber(tmpVals[1])~=nil and tmpVals[2]~=nil then
				QStype=tonumber(tmpVals[1]);
				QSdata=tmpVals[2];
			end
			tmpControl.Child[newChildIndex]=Turbine.UI.Control();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetVisible( true );
			tmpControl.Child[newChildIndex]:SetMouseVisible( false );
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			tmpControl.Child[newChildIndex]:SetPosition(left,top);
			tmpControl.Child[newChildIndex].QS=Turbine.UI.Lotro.Quickslot();
			tmpControl.Child[newChildIndex].QS:SetParent(tmpControl.Child[newChildIndex]);
			tmpControl.Child[newChildIndex].QS:SetVisible( true );
			tmpControl.Child[newChildIndex].QS:SetMouseVisible( true );
			tmpControl.Child[newChildIndex].QS:SetSize(width,height);
			if left==nil then left=0 end
			if top==nil then top=0 end
			tmpControl.Child[newChildIndex].QS:SetPosition(0,0);
			tmpControl.Child[newChildIndex].QS:SetAllowDrop(false);
			tmpControl.Child[newChildIndex].QS.QStype=QStype;
			tmpControl.Child[newChildIndex].QS.QSdata=QSdata;

			local sc=Turbine.UI.Lotro.Shortcut();
			sc:SetType(QStype);
			sc:SetData(QSdata);
			local isValid, result=pcall(Turbine.UI.Lotro.Quickslot.SetShortcut,tmpControl.Child[newChildIndex].QS,sc);
			if isValid then
				if QStype==Turbine.UI.Lotro.ShortcutType.Item then
					local tmpItem=sc:GetItem();
					if tmpItem~=nil then
						local tmpItemInfo=tmpItem:GetItemInfo();
						if tmpItemInfo~=nil then
							local tmpIcon=tmpItemInfo:GetBackgroundImageID();
							if tmpIcon~=nil and tmpIcon~=0 then
								tmpControl.Child[newChildIndex].ItemBack=Turbine.UI.Control();
								tmpControl.Child[newChildIndex].ItemBack:SetParent(tmpControl.Child[newChildIndex]);
								tmpControl.Child[newChildIndex].ItemBack:SetSize(width-4,height-4);
								tmpControl.Child[newChildIndex].ItemBack:SetPosition(3,3);
								tmpControl.Child[newChildIndex].ItemBack:SetMouseVisible(false);
								tmpControl.Child[newChildIndex].ItemBack:SetBlendMode(Turbine.UI.BlendMode.Overlay);
								tmpControl.Child[newChildIndex].ItemBack:SetBackground(tmpIcon);
							end
							local tmpIcon=tmpItemInfo:GetShadowImageID();
							if tmpIcon~=nil and tmpIcon~=0 then
								tmpControl.Child[newChildIndex].ItemShadow=Turbine.UI.Control();
								tmpControl.Child[newChildIndex].ItemShadow:SetParent(tmpControl.Child[newChildIndex]);
								tmpControl.Child[newChildIndex].ItemShadow:SetSize(width-4,height-4);
								tmpControl.Child[newChildIndex].ItemShadow:SetPosition(3,3);
								tmpControl.Child[newChildIndex].ItemShadow:SetMouseVisible(false);
								tmpControl.Child[newChildIndex].ItemShadow:SetBlendMode(Turbine.UI.BlendMode.Overlay);
								tmpControl.Child[newChildIndex].ItemShadow:SetBackground(tmpIcon);
							end
							local tmpIcon=tmpItemInfo:GetUnderlayImageID();
							if tmpIcon~=nil and tmpIcon~=0 then
								tmpControl.Child[newChildIndex].ItemUnderlay=Turbine.UI.Control();
								tmpControl.Child[newChildIndex].ItemUnderlay:SetParent(tmpControl.Child[newChildIndex]);
								tmpControl.Child[newChildIndex].ItemUnderlay:SetSize(width-4,height-4);
								tmpControl.Child[newChildIndex].ItemUnderlay:SetPosition(3,3);
								tmpControl.Child[newChildIndex].ItemUnderlay:SetMouseVisible(false);
								tmpControl.Child[newChildIndex].ItemUnderlay:SetBlendMode(Turbine.UI.BlendMode.Overlay);
								tmpControl.Child[newChildIndex].ItemUnderlay:SetBackground(tmpIcon);
							end
							local tmpIcon=tmpItemInfo:GetIconImageID();
							if tmpIcon~=nil and tmpIcon~=0 then
								tmpControl.Child[newChildIndex].ItemIcon=Turbine.UI.Control();
								tmpControl.Child[newChildIndex].ItemIcon:SetParent(tmpControl.Child[newChildIndex]);
								tmpControl.Child[newChildIndex].ItemIcon:SetSize(width-4,height-4);
								tmpControl.Child[newChildIndex].ItemIcon:SetPosition(3,3);
								tmpControl.Child[newChildIndex].ItemIcon:SetMouseVisible(false);
								tmpControl.Child[newChildIndex].ItemIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
								tmpControl.Child[newChildIndex].ItemIcon:SetBackground(tmpIcon);
							end
						end
					end
				end
				tmpControl.Child[newChildIndex].QS.DragDrop=function(sender)
					local sc=Turbine.UI.Lotro.Shortcut();
					sc:SetType(sender.QStype);
					sc:SetData(sender.QSdata);
					sender:SetShortcut(sc);
				end
			else
				-- hmmm, the quickslot data was invalid...
			end

		elseif type=="mask" then
			tmpControl.Child[newChildIndex]=Turbine.UI.Label();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetSelectable(true)
			if color~=nil then
				tmpControl.Child[newChildIndex]:SetForeColor(color);
			end
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			tmpControl.Child[newChildIndex]:SetText(data);
			if width==nil then width=self.DisplayFrame:GetWidth() end
			if height==nil then height=tmpControl:GetHeight() end
			tmpControl.Child[newChildIndex]:SetSize(width,height);
			tmpControl.Child[newChildIndex]:SetBackColor(Turbine.UI.Color(0,0,0));
			tmpControl.Child[newChildIndex]:SetMouseVisible(false);


		elseif type=="borderedlabel" then
			local borderSize=1;
			tmpControl.Child[newChildIndex]=Turbine.UI.Label(); -- child label control that will display within the border
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetBackColor(Turbine.UI.Color(0,0,0)); -- overrides the border color within the text area
			tmpControl.Child[newChildIndex]:SetPosition(borderSize,borderSize);
			tmpControl.Child[newChildIndex]:SetSelectable(true)
			if color~=nil then
				tmpControl.Child[newChildIndex]:SetForeColor(color);
			end
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			if width==nil then
				width=self.DisplayFrame:GetWidth();
			end
			tmpControl.Child[newChildIndex]:SetText(data);
			tmpControl.Child[newChildIndex]:SetSize(width-2*borderSize,height-2*borderSize); -- again, assumes a 1 pixel border
		else
			tmpControl.Child[newChildIndex]=Turbine.UI.Label();
			tmpControl.Child[newChildIndex]:SetParent(tmpControl);
			tmpControl.Child[newChildIndex]:SetSelectable(true)
			if color~=nil then
				tmpControl.Child[newChildIndex]:SetForeColor(color);
			end
			if font~=nil then
				tmpControl.Child[newChildIndex]:SetFont(font);
			end
			if left==nil then left=0 end
			if top==nil then top=0 end
			tmpControl.Child[newChildIndex]:SetPosition(left,top);
			tmpControl.Child[newChildIndex]:SetText(data);
			if width==nil then width=self.DisplayFrame:GetWidth() end
			if height==nil then height=tmpControl:GetHeight() end
			tmpControl.Child[newChildIndex]:SetSize(width,height);
		end
		tmpControl.Child[newChildIndex].Type=type;
		if newChildIndex==1 then
			tmpControl:SetParent(self.DisplayFrame);
			self.DisplayFrame:AddItem(tmpControl);
		end
		-- we wait until the control is completely initialized before firing the optional initEvent
		if initEvent~=nil then
			initEvent(tmpControl.Child[newChildIndex]); -- we pass the newly created control to the initEvent
		end
	end
	self.ShowDisplayFrame=function()
		self.CurrentWidth=500;
	        self:SetSize(500, 400);

		self.DisplayFrame:SetPosition(10,55);
		self.DisplayFrame:SetSize(self:GetWidth()-30,self:GetHeight()-90);
		self.DisplayScroll:SetTop(self.DisplayFrame:GetTop());
		self.DisplayScroll:SetHeight(self.DisplayFrame:GetHeight());
		self.DisplayFrame:SetVisible(true);
		self.Background:SetVisible(false);

		for k,v in pairs(self.customButtons) do
			v:SetVisible(false);
		end
		self.volverButton:SetVisible( true );
	end

-- using child controls raises an issue with fixed left positioning versus dynamic positioning
	self.DisplayFrame.SizeChanged=function()
		local tmpIndex;
		local newWidth=self.DisplayFrame:GetWidth();
		for tmpIndex=1,self.DisplayFrame:GetItemCount() do
			local tmpRow=self.DisplayFrame:GetItem(tmpIndex);
			tmpRow:SetWidth(newWidth);
			if #tmpRow.Child==1 then
				local tmpItem=tmpRow.Child[1];
				if tmpItem.Centered~=nil and tmpItem.Centered==true then
					tmpItem:SetLeft((newWidth-tmpItem:GetWidth())/2);
				else
					if tmpItem.Type=="button" or tmpItem.Type=="textbox" then
						-- don't allow resizing buttons or text boxes
					else
						tmpItem:SetWidth(newWidth);
					end
				end
				if tmpItem.QSBorder~=nil then
					tmpItem.QSBorder:SetLeft((newWidth-tmpItem.QSBorder:GetWidth())/2)
				end
			else
				for tmpChildIndex=1,#tmpRow.Child do
					local tmpItem=tmpRow.Child[tmpChildIndex];
					if tmpItem.Centered~=nil and tmpItem.Centered==true then
						tmpItem:SetLeft((newWidth-tmpItem:GetWidth())/2);
					else
--						tmpItem:SetWidth(newWidth);
					end
					if tmpItem.QSBorder~=nil then
						tmpItem.QSBorder:SetLeft((newWidth-tmpItem.QSBorder:GetWidth())/2)
					end
				end
			end
		end
		self.DisplayScroll:SetLeft(newWidth+10);
	end

	StratDisplayWindow.Closing=function(args)
		windowSettings.positionXstratdisplay, windowSettings.positionYstratdisplay=self:GetPosition();
		self.volverButton:Click(); -- force a resize to button menu
		Hellish:SetVisible(true);
	end

	self:SetResizable(true);
	self.CurrentWidth=365;

	self.PositionChanged=function()
		local x,y=self:GetMousePosition();
		-- something weird is happening if we size the window from the left border
		-- this code helps to suppress this, although it can still occur if you drag far enough
		if self:GetWidth()~=self.CurrentWidth then
			self:SetLeft(self:GetLeft()-(self.CurrentWidth-self:GetWidth()))
		end

		if self:GetLeft()+self:GetWidth()>Turbine.UI.Display:GetWidth() then
			self:SetLeft(Turbine.UI.Display:GetWidth()-self:GetWidth())
		end
		self.CurrentLeft=self:GetLeft();

	end

	self.CurrentLeft=self:GetLeft();
	self.SizeChanged=function(sender, args)
		Turbine.UI.Lotro.Window.SetWidth(self,self.CurrentWidth)
		self.DisplayFrame:SetSize(self.CurrentWidth-30,self:GetHeight()-90)
		self.DisplayScroll:SetHeight(self.DisplayFrame:GetHeight());
		self.ChannelCaption:SetTop(self:GetHeight()-30);
		self.ChannelText:SetTop(self:GetHeight()-30);
	end

end

function StratDisplayWindow:LoadSettings()
	if type( windowSettings ) ~= "table" then
		windowSettings = { positionXstratdisplay = 100, positionYitemsid = 100 };
	else
		if windowSettings.positionXstratdisplay == nil then
			windowSettings.positionXstratdisplay = 100;
		end
		if windowSettings.positionYstratdisplay == nil then
			windowSettings.positionYstratdisplay = 100;
		end
	end
end

